"use strict";

exports.__esModule = true;
exports["default"] = buildChildren;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _cleanText = require("./clean-text");

var _cleanText2 = _interopRequireDefault(_cleanText);

var _astToFunctionCall = require("./ast/to-function-call");

var _astToFunctionCall2 = _interopRequireDefault(_astToFunctionCall);

var _runtimeRenderArbitrary = require("./runtime/render-arbitrary");

var _runtimeRenderArbitrary2 = _interopRequireDefault(_runtimeRenderArbitrary);

var _idomMethod = require("./idom-method");

var _idomMethod2 = _interopRequireDefault(_idomMethod);

var _astIsLiteralOrUndefined = require("./ast/is-literal-or-undefined");

var _astIsLiteralOrUndefined2 = _interopRequireDefault(_astIsLiteralOrUndefined);

// Filters out empty children, and transform JSX expressions
// into function calls.

function buildChildren(t, scope, file, children, _ref) {
  var eager = _ref.eager;

  var renderArbitraryRef = undefined;
  var eagerChildren = [];

  children = children.reduce(function (children, child) {
    var wasInExpressionContainer = t.isJSXExpressionContainer(child);
    if (wasInExpressionContainer) {
      child = child.expression;
    }

    if (t.isJSXEmptyExpression(child)) {
      return children;
    }

    if (_astIsLiteralOrUndefined2["default"](t, child)) {
      var value = child.value;
      var type = typeof value;

      if (type === "string") {
        value = _cleanText2["default"](value);
        if (!value) {
          return children;
        }
      }

      if (type === "string" || type === "number") {
        child = _astToFunctionCall2["default"](t, _idomMethod2["default"](file, "text"), [t.literal(value)]);
      }
    } else if (wasInExpressionContainer && !child._iDOMwasJSX) {
      renderArbitraryRef = renderArbitraryRef || _runtimeRenderArbitrary2["default"](t, file);

      if (eager) {
        var ref = scope.generateUidIdentifierBasedOnNode(child);
        eagerChildren.push(t.variableDeclarator(ref, child));
        child = ref;
      }

      child = _astToFunctionCall2["default"](t, renderArbitraryRef, [child]);
    }

    children.push(child);
    return children;
  }, []);

  return { children: children, eagerChildren: eagerChildren };
}

module.exports = exports["default"];