// Places all our eager declarators **before** the current path's statement,
// so that the path or sub-paths may be transformed into a lazily evaluated
// function.
"use strict";

exports.__esModule = true;
exports["default"] = eagerlyDeclare;

function eagerlyDeclare(t, scope, path, eagerDeclarators) {
  // Find the closest statement, and insert our eager declarations
  // before it.
  var parentStatement = path.getStatementParent();
  var declarationPath = parentStatement.insertBefore(t.variableDeclaration("let", eagerDeclarators));

  // Add our eager declarations to the scope's tracked bindings.
  scope.registerBinding("let", declarationPath[0]);
}

module.exports = exports["default"];