"use strict";

exports.__esModule = true;
exports.setupHoists = setupHoists;
exports.hoistStatics = hoistStatics;
exports["default"] = addStaticHoist;
var namespace = "incremental-dom-hoists";

// Sets up the file to hoist all statics

function setupHoists(program, parent, scope, file) {
  // A map to store helper variable references
  // for each file
  file.set(namespace, []);
}

function hoistStatics(t, file, path) {
  var hoists = file.get(namespace);

  if (hoists.length) {
    var declaration = t.variableDeclaration("const", hoists);
    path.unshiftContainer("body", declaration);
  }
}

function addStaticHoist(t, scope, file, statics, key, keyIndex) {
  var id = scope.generateUidIdentifier("statics");
  var declarator = t.variableDeclarator(id, statics);
  var staticAssignment = null;

  var hoists = file.get(namespace);
  hoists.push(declarator);

  if (keyIndex > -1) {
    // We need to assign the key variable's value to the statics array at `index`.
    staticAssignment = t.expressionStatement(t.assignmentExpression("=", t.memberExpression(id, t.literal(keyIndex), true), key));
  }

  return { id: id, staticAssignment: staticAssignment };
}