"use strict";

exports.__esModule = true;
exports["default"] = injectAttr;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _inject = require("../inject");

var _inject2 = _interopRequireDefault(_inject);

var _astToFunctionCallStatement = require("../ast/to-function-call-statement");

var _astToFunctionCallStatement2 = _interopRequireDefault(_astToFunctionCallStatement);

var _idomMethod = require("../idom-method");

var _idomMethod2 = _interopRequireDefault(_idomMethod);

// Flip flops the arguments when calling iDOM's
// `attr`, so that this function may be used
// as an iterator like an Object#forEach.
function attrAST(t, file, ref) {
  var name = t.identifier("name");
  var value = t.identifier("value");

  /**
   * function _attr(value, prop) {
   *   attr(prop, value);
   * }
   */
  return t.functionDeclaration(ref, [value, name], t.blockStatement([_astToFunctionCallStatement2["default"](t, _idomMethod2["default"](file, "attr"), [name, value])]));
}

function injectAttr(t, file) {
  return _inject2["default"](t, file, "attr", attrAST);
}

module.exports = exports["default"];